Subject: Re: bug#56682: Fix the long lines font locking related slowdowns

From: Stephen Berman <[email-masked]>
Date: Wed, 10 Aug 2022 13:59:45 +0200

On Wed, 10 Aug 2022 14:44:59 +0300 Eli Zaretskii <[email-masked]> wrote:

>> Date: Wed, 10 Aug 2022 10:34:32 +0000
>> From: Gregory Heytings <[email-masked]>
>> cc: [email-masked], Eli Zaretskii <[email-masked]>,
>>     [email-masked], Dmitry Gutov <[email-masked]>
>>
>> Another option might be to add some limits to the algorithm in
>> buffers with long lines, without disabling it completely.
>
> It already has such limits and other optimizations.  Inhibiting the
> BPA is an option if it is known that the buffer doesn't include ant
> R2L characters anywhere; otherwise some braces/parens could be
> displayed incorrectly mirrored.
>
> If you remove the 3 closing braces/brackets at EOB and the
> corresponding opening braces/brackets, does navigation become
> significantly faster?

After removing those brackets, holding down `C-n' or `C-p' does seem a
bit faster with bidi-inhibit-bpa nil, but not anywhere near as fast as
with bidi-inhibit-bpa non-nil.

>                        These are the only brackets I could spot in the
> file that enclose very large portions of text.  If removing them
> doesn't help much, the only possible reason is that there are a lot of
> bracketed stuff in this file.

I suppose so, though I guess this is a pretty typical one-line JSON
file.

Steve Berman